SystemOrganization addCategory: #'AsmJit-Extension'!

!WriteStream methodsFor: '*AsmJit-Extension' stamp: 'CamilloBruni 8/23/2012 15:55'!
asLineStream
	^ AJLineStream on: self! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asAJOperand

	"Convert receiver into operand: a signed immediate"
	^ AJImmediate new ivalue: self! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asByte
	^ self asTwosComplement: 16rFF! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asDoubleWord
	^ self asTwosComplement: 16rFFFFFFFF! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asImm

	"Convert integer value into a signed immediate operand"
	^ AJImmediate new ivalue: self! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asImm16

	"Convert integer value into a signed immediate word operand "
	^ AJImmediate new ivalue: self; size: 2! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asImm32

	"Convert integer value into a signed immediate operand"
	^ AJImmediate new ivalue: self; size: 4! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asImm8

	"Convert integer value into a signed immediate operand"
	^ AJImmediate new ivalue: self; size: 1! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asQuadWord
	^ self asTwosComplement: 16rFFFFFFFFFFFFFFFF! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asTwosComplement: mask
	"return the two's completemented cropped version.
	Example for a byte value:
		-5 asTwosComplement: 16rFF "
	| bound |
	bound := (mask + 1).
	
	self * 2 >= bound 
		ifTrue: [Error signal: self printString , ' too big for signed ', mask highBit printString,  'bit value'].
		 
	(self >= 0)
		ifTrue: [ ^ self bitAnd: mask ].
		
	self * 2 < bound negated 
		ifTrue: [Error signal: self printString , ' too small for signed ', mask highBit printString, 'bit value'].
		
	^ (self + mask + 1) bitAnd: mask! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asUImm

	"Convert integer value into an unsigned immediate operand"
	^ AJImmediate new uvalue: self! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asUImm16

	"Convert integer value into an unsigned immediate operand"
	^ AJImmediate new uvalue: self; size: 2! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asUImm32

	"Convert integer value into an unsigned immediate operand"
	^ AJImmediate new uvalue: self; size: 4! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asUImm8

	"Convert integer value into an unsigned immediate operand"
	^ AJImmediate new uvalue: self; size: 1! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
asWord
	^ self asTwosComplement: 16rFFFF! !

!Integer methodsFor: '*AsmJit-Extension' stamp: 'CamilloBruni 5/14/2012 17:18'!
bin
	"Print the receiver as hex, prefixed with 2r."
	^self storeStringBase: 2! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
isByte
	^ self >= 0 and: [ self <= 255 ]! !

!Integer methodsFor: '*AsmJit-Extension' stamp: ''!
printAsOperandOn: aStream
	aStream print: self.! !

Object subclass: #AJLineStream
	instanceVariableNames: 'lineStart writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AsmJit-Extension'!

!AJLineStream class methodsFor: 'instance creation' stamp: 'CamilloBruni 7/16/2012 15:33'!
on: aWriteStream 
	^ self new 
		writeStream: aWriteStream;
		yourself! !

!AJLineStream methodsFor: 'writing' stamp: ''!
cr
	self updateLineStart.
	writeStream cr! !

!AJLineStream methodsFor: 'writing' stamp: ''!
crlf
	self updateLineStart.
	writeStream crlf! !

!AJLineStream methodsFor: 'error handling' stamp: 'CamilloBruni 7/16/2012 14:59'!
doesNotUnderstand: aMessage
	writeStream 
		perform: aMessage selector 
		withArguments: aMessage arguments! !

!AJLineStream methodsFor: 'writing' stamp: ''!
lf
	self updateLineStart.
	writeStream lf! !

!AJLineStream methodsFor: 'writing' stamp: 'CamilloBruni 7/16/2012 15:00'!
on: aStream 
	^ self new 
		writeStream: aStream;
		yourself! !

!AJLineStream methodsFor: 'writing' stamp: 'CamilloBruni 7/16/2012 15:23'!
padColumn: maxCharacterPosition
	"pad the current line up to maxCharacterPosition with spaces"
	[writeStream position - lineStart < maxCharacterPosition]
		whileTrue: [writeStream space]! !

!AJLineStream methodsFor: 'writing' stamp: ''!
updateLineStart
	lineStart := writeStream position! !

!AJLineStream methodsFor: 'writing' stamp: 'CamilloBruni 7/16/2012 15:22'!
writeStream: aWriteStream 
	writeStream := aWriteStream.
	self updateLineStart! !
